/***************************************************************************
                          main.c  -  Simple E/C PostgreSQL example
                             -------------------
    begin                : Wed Dec  1 10:50:30 EDT 2006
    copyright            : (C) 2006 by Kenneth Jennings
    email                : synthetoonz@bellsouth.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/*
 * =============================================================================
 * $Log: main.c,v $
 * Revision 1.6  2006/12/29 03:20:32  kenjen
 * Separated generic DB functions from specific table
 * operations.  Also enhanced error detection and the diagnostic
 * information being reported from sqlca.
 *
 * Revision 1.5  2006/12/27 05:29:58  kenjen
 * Split db functions into generic db.pgc file and
 * a table-specific test_pgc.pgc file.
 *
 * Revision 1.4  2006/12/01 20:59:29  kjenning
 * The test will do all commits so it isn't
 * necessary to do it in main(), too.
 *
 * Revision 1.3  2006/12/01 19:04:29  kjenning
 * Tidy up the usage information.
 *
 * Revision 1.2  2006/12/01 19:00:48  kjenning
 * Added string.h.
 *
 * Revision 1.1  2006/12/01 18:58:23  kjenning
 * Initial revision
 *
 * =============================================================================
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "db.h"
#include "test_pgc.h"

static char rcsid[] = "$Id: main.c,v 1.6 2006/12/29 03:20:32 kenjen Exp $";

char * mainRCSID(void) { return rcsid ; }


int main( int argc, char ** argv)
{
	if ( (argc >= 2) && ( !strcmp( argv[1], "-v" ) ) )
	{
		fprintf(stderr, "Test PostgreSQL ESQL/C\n\n%s\n%s\n%s\n\n",
				mainRCSID(), dbRCSID(), test_pgcRCSID() );
	}

	if ( argc != 3)
	{
		fprintf(stderr, "Usage: testpgc dbname user\n\n"
				"\tParameters are used in SQL Connection Statement as follows:\n\n"
				"\t\tCONNECT TO dbname USER user\n\n"
				"\tdbname - may  be a simple database name or a URL connect string.\n"
				"\tuser   - may be a user name, or username/password string\n");
		return -1;
	}

	if ( db_connect( argv[1], argv[2] ) < 0 )
		return -2;

	if ( test_pgc() < 0 )
	{
		db_disconnect();

		return -3;
	}

	if ( db_disconnect() < 0 )
		return -4;

	return 0;
}

